'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncHelper = require('../async-helper');

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = [attributeWalker].map(_regenerator2.default.mark);

function getFileNameBody(filePath) {
    return _path2.default.parse(filePath).name;
}

var templateDir = _path2.default.join(__dirname, "../../src/doc/templates/");

function attributeWalker(attributes) {
    var currentHead, currentBody, parsingHead, currentBracket, i, current, needAppend;
    return _regenerator2.default.wrap(function attributeWalker$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    currentHead = "";
                    currentBody = "";
                    parsingHead = true;
                    currentBracket = 0;
                    i = 0;

                case 5:
                    if (!(i < attributes.length)) {
                        _context.next = 26;
                        break;
                    }

                    current = attributes.charAt(i);

                    if (!parsingHead) {
                        _context.next = 11;
                        break;
                    }

                    if (current !== ":") {
                        currentHead += current;
                    } else {
                        parsingHead = false;
                        currentHead = currentHead.trim();
                    }
                    _context.next = 23;
                    break;

                case 11:
                    needAppend = true;

                    if (current === "{" || current === "(" || current === "[" || current === "<") {
                        if (currentBracket === 0 && current === "{") {
                            needAppend = false;
                        }
                        currentBracket++;
                    }
                    if (current === "}" || current === ")" || current === "]" || current === ">") {
                        currentBracket--;
                        if (currentBracket === 0 && current === "}") {
                            needAppend = false;
                        }
                    }

                    if (!(current === "," && currentBracket === 0)) {
                        _context.next = 22;
                        break;
                    }

                    _context.next = 17;
                    return {
                        name: currentHead,
                        body: currentBody
                    };

                case 17:
                    currentHead = "";
                    currentBody = "";
                    currentBracket = 0;
                    parsingHead = true;
                    needAppend = false;

                case 22:

                    if (needAppend) {
                        currentBody += current;
                    }

                case 23:
                    i++;
                    _context.next = 5;
                    break;

                case 26:
                    _context.next = 28;
                    return {
                        name: currentHead,
                        body: currentBody
                    };

                case 28:
                case 'end':
                    return _context.stop();
            }
        }
    }, _marked[0], this);
}

var generateForComponents = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(config) {
        var files, i, content, contentName, regex, result, target, bracketCount, j, char, attributes;
        return _regenerator2.default.wrap(function _callee$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return (0, _asyncHelper.globAsync)(config.ts.src + "/**/*Component.ts");

                    case 2:
                        files = _context2.sent;
                        i = 0;

                    case 4:
                        if (!(i < files.length)) {
                            _context2.next = 29;
                            break;
                        }

                        _context2.next = 7;
                        return (0, _asyncHelper.readFileAsync)(files[i]);

                    case 7:
                        content = _context2.sent;
                        contentName = getFileNameBody(files[i]).match(/.+(?=Component)/)[0];
                        regex = /static[\s\n]+attributes[\s\n]*:[^}]*}[\s\n]*=[\s\n*]{([\s\S]+})/g;

                        content = content.replace(/\/\*[\s\S]*?\*\//, "").replace(/\/\/.*/, "");
                        result = regex.exec(content);
                        target = result[1];
                        bracketCount = 1;
                        j = void 0;
                        j = 0;

                    case 16:
                        if (!(j < target.length)) {
                            _context2.next = 24;
                            break;
                        }

                        char = target.charAt(j);

                        if (char === "{") {
                            bracketCount++;
                        } else if (char === "}") {
                            bracketCount--;
                        }

                        if (!(bracketCount === 0)) {
                            _context2.next = 21;
                            break;
                        }

                        return _context2.abrupt('break', 24);

                    case 21:
                        j++;
                        _context2.next = 16;
                        break;

                    case 24:
                        attributes = target.substr(0, j);

                        generatefiles(attributes, contentName, config);

                    case 26:
                        i++;
                        _context2.next = 4;
                        break;

                    case 29:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function generateForComponents(_x) {
        return _ref.apply(this, arguments);
    };
}();

var generatefiles = function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(attributes, contentName, config) {
        var fileName, component, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, attrs, converter, defaultValue, other, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, attrChild, fileBody, regex, regexResult, descriptions, headerTemplated, tableTemplated, attributesDescription;

        return _regenerator2.default.wrap(function _callee2$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        fileName = _path2.default.join(config.doc.src, "Components", contentName + '.md');
                        component = {
                            componentName: contentName,
                            attributes: []
                        };
                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context3.prev = 5;
                        _iterator = (0, _getIterator3.default)(attributeWalker(attributes));

                    case 7:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            _context3.next = 55;
                            break;
                        }

                        attrs = _step.value;

                        if (!(attrs.name.length === 0 || attrs.body.length === 0)) {
                            _context3.next = 11;
                            break;
                        }

                        return _context3.abrupt('continue', 52);

                    case 11:
                        converter = undefined;
                        defaultValue = undefined;
                        other = "";
                        _iteratorNormalCompletion2 = true;
                        _didIteratorError2 = false;
                        _iteratorError2 = undefined;
                        _context3.prev = 17;
                        _iterator2 = (0, _getIterator3.default)(attributeWalker(attrs.body));

                    case 19:
                        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                            _context3.next = 34;
                            break;
                        }

                        attrChild = _step2.value;

                        if (!(attrChild.name === "converter")) {
                            _context3.next = 25;
                            break;
                        }

                        converter = attrChild.body.trim();
                        converter = converter.substring(1, converter.length - 1);
                        return _context3.abrupt('continue', 31);

                    case 25:
                        if (!(attrChild.name === "defaultValue")) {
                            _context3.next = 28;
                            break;
                        }

                        defaultValue = attrChild.body.trim();
                        return _context3.abrupt('continue', 31);

                    case 28:
                        if (!(attrChild.name.length === 0 || attrChild.body.length === 0)) {
                            _context3.next = 30;
                            break;
                        }

                        return _context3.abrupt('continue', 31);

                    case 30:
                        other += '`' + attrChild.name + '`</br>' + attrChild.body + '</br>';

                    case 31:
                        _iteratorNormalCompletion2 = true;
                        _context3.next = 19;
                        break;

                    case 34:
                        _context3.next = 40;
                        break;

                    case 36:
                        _context3.prev = 36;
                        _context3.t0 = _context3['catch'](17);
                        _didIteratorError2 = true;
                        _iteratorError2 = _context3.t0;

                    case 40:
                        _context3.prev = 40;
                        _context3.prev = 41;

                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }

                    case 43:
                        _context3.prev = 43;

                        if (!_didIteratorError2) {
                            _context3.next = 46;
                            break;
                        }

                        throw _iteratorError2;

                    case 46:
                        return _context3.finish(43);

                    case 47:
                        return _context3.finish(40);

                    case 48:
                        other = other.trim();
                        other = other.replace(/\n/g, "</br>");
                        if (other.length === 0 || other === ":") {
                            other = "なし";
                        }
                        component.attributes.push({
                            name: attrs.name.replace(/[\s]/g, ""),
                            converter: converter,
                            defaultValue: defaultValue,
                            other: other
                        });

                    case 52:
                        _iteratorNormalCompletion = true;
                        _context3.next = 7;
                        break;

                    case 55:
                        _context3.next = 61;
                        break;

                    case 57:
                        _context3.prev = 57;
                        _context3.t1 = _context3['catch'](5);
                        _didIteratorError = true;
                        _iteratorError = _context3.t1;

                    case 61:
                        _context3.prev = 61;
                        _context3.prev = 62;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 64:
                        _context3.prev = 64;

                        if (!_didIteratorError) {
                            _context3.next = 67;
                            break;
                        }

                        throw _iteratorError;

                    case 67:
                        return _context3.finish(64);

                    case 68:
                        return _context3.finish(61);

                    case 69:
                        fileBody = "";
                        _context3.prev = 70;
                        _context3.next = 73;
                        return (0, _asyncHelper.readFileAsync)(fileName);

                    case 73:
                        fileBody = _context3.sent;
                        _context3.next = 78;
                        break;

                    case 76:
                        _context3.prev = 76;
                        _context3.t2 = _context3['catch'](70);

                    case 78:
                        regex = /<!-- EDIT HERE\(([\w\d@]+)\)-->([\s\S]*?)<!-- \/EDIT HERE-->/g;
                        regexResult = void 0;
                        descriptions = {};

                        while (regexResult = regex.exec(fileBody)) {
                            descriptions[regexResult[1]] = regexResult[2];
                        }

                        if (descriptions["@Component"] === void 0) {
                            descriptions["@Component"] = "\n";
                        }
                        component.attributes.forEach(function (attr) {
                            if (descriptions[attr.name] === void 0) {
                                descriptions[attr.name] = "\n";
                            }
                        });
                        component.attributes.forEach(function (attr) {
                            attr.description = descriptions[attr.name];
                        });
                        _context3.next = 87;
                        return (0, _asyncHelper.templateAsync)(templateDir + "/markdown-header.template", {
                            componentName: contentName,
                            description: descriptions["@Component"]
                        });

                    case 87:
                        headerTemplated = _context3.sent;
                        _context3.next = 90;
                        return (0, _asyncHelper.templateAsync)(templateDir + "markdown-attribute-table.template", {
                            attributes: component.attributes
                        });

                    case 90:
                        tableTemplated = _context3.sent;

                        if (component.attributes.length === 0) {
                            tableTemplated = "属性なし";
                        }
                        _context3.next = 94;
                        return (0, _asyncHelper.templateAsync)(templateDir + "markdown-attribute.template", {
                            attributes: component.attributes
                        });

                    case 94:
                        attributesDescription = _context3.sent;
                        _context3.next = 97;
                        return (0, _asyncHelper.writeFileAsync)(fileName, headerTemplated + tableTemplated + attributesDescription);

                    case 97:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee2, undefined, [[5, 57, 61, 69], [17, 36, 40, 48], [41,, 43, 47], [62,, 64, 68], [70, 76]]);
    }));

    return function generatefiles(_x2, _x3, _x4) {
        return _ref2.apply(this, arguments);
    };
}();

var generateIndex = function () {
    var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(config) {
        var header, footer, files, content, i, templated;
        return _regenerator2.default.wrap(function _callee3$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return (0, _asyncHelper.ensureFileAsync)(config.doc.header);

                    case 2:
                        _context4.next = 4;
                        return (0, _asyncHelper.ensureFileAsync)(config.doc.footer);

                    case 4:
                        _context4.next = 6;
                        return (0, _asyncHelper.readFileAsync)(config.doc.header);

                    case 6:
                        header = _context4.sent;
                        _context4.next = 9;
                        return (0, _asyncHelper.readFileAsync)(config.doc.footer);

                    case 9:
                        footer = _context4.sent;
                        _context4.next = 12;
                        return (0, _asyncHelper.globAsync)(config.doc.src + "/*/**/*.md");

                    case 12:
                        files = _context4.sent;
                        content = [];
                        i = 0;

                    case 15:
                        if (!(i < files.length)) {
                            _context4.next = 24;
                            break;
                        }

                        _context4.t0 = content;
                        _context4.next = 19;
                        return (0, _asyncHelper.readFileAsync)(files[i]);

                    case 19:
                        _context4.t1 = _context4.sent;

                        _context4.t0.push.call(_context4.t0, _context4.t1);

                    case 21:
                        i++;
                        _context4.next = 15;
                        break;

                    case 24:
                        _context4.next = 26;
                        return (0, _asyncHelper.templateAsync)(templateDir + "markdown-index.template", {
                            header: header,
                            footer: footer,
                            component: content
                        });

                    case 26:
                        templated = _context4.sent;
                        _context4.next = 29;
                        return (0, _asyncHelper.writeFileAsync)(config.doc.dest, templated);

                    case 29:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee3, undefined);
    }));

    return function generateIndex(_x5) {
        return _ref3.apply(this, arguments);
    };
}();

var parseConfig = function () {
    var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        var config;
        return _regenerator2.default.wrap(function _callee4$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.t0 = JSON;
                        _context5.next = 3;
                        return (0, _asyncHelper.readFileAsync)("./package.json");

                    case 3:
                        _context5.t1 = _context5.sent;
                        config = _context5.t0.parse.call(_context5.t0, _context5.t1);

                        config.grimoire = config.grimoire ? config.grimoire : {};
                        return _context5.abrupt('return', config);

                    case 7:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee4, undefined);
    }));

    return function parseConfig() {
        return _ref4.apply(this, arguments);
    };
}();

var main = function () {
    var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
        var config;
        return _regenerator2.default.wrap(function _callee5$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.next = 2;
                        return parseConfig();

                    case 2:
                        config = _context6.sent.grimoire;
                        _context6.prev = 3;
                        _context6.next = 6;
                        return generateForComponents(config);

                    case 6:
                        _context6.next = 8;
                        return generateIndex(config);

                    case 8:
                        _context6.next = 13;
                        break;

                    case 10:
                        _context6.prev = 10;
                        _context6.t0 = _context6['catch'](3);

                        console.log(_context6.t0);

                    case 13:
                    case 'end':
                        return _context6.stop();
                }
            }
        }, _callee5, undefined, [[3, 10]]);
    }));

    return function main() {
        return _ref5.apply(this, arguments);
    };
}();

exports.default = main;