"use strict";

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var generateIndex = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        var _this = this;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.prev = 0;
                        return _context3.delegateYield(_regenerator2.default.mark(function _callee2() {
                            var cwd, pkgJson, projectSuffix, destFileLocation, mainFileLocation, basePath, detectedFiles, pathMap, interfaces, i, relative, absolute, content, separated, keyPath, structureObject, _keyPath, jsonCode, objectCode, imports, _keyPath2, index, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _pathes, templateArgs;

                            return _regenerator2.default.wrap(function _callee2$(_context2) {
                                while (1) {
                                    switch (_context2.prev = _context2.next) {
                                        case 0:
                                            cwd = process.cwd(); // current working directory

                                            _context2.t0 = JSON;
                                            _context2.next = 4;
                                            return (0, _asyncHelper.readFileAsync)(_path2.default.join(cwd, "package.json"));

                                        case 4:
                                            _context2.t1 = _context2.sent;
                                            pkgJson = _context2.t0.parse.call(_context2.t0, _context2.t1);
                                            projectSuffix = getSuffix(pkgJson.name);
                                            destFileLocation = _path2.default.resolve(_path2.default.join(cwd, _yargs.argv.dest));
                                            mainFileLocation = _path2.default.resolve(_path2.default.join(cwd, _yargs.argv.main));
                                            basePath = _path2.default.join(cwd, _yargs.argv.src); // absolute path of source directory

                                            _context2.next = 12;
                                            return (0, _asyncHelper.globAsync)(_path2.default.join(cwd, _yargs.argv.src, _yargs.argv.ts ? "**/*.ts" : "**/*.js"));

                                        case 12:
                                            detectedFiles = _context2.sent;
                                            // glob all javascript files
                                            if (_yargs.argv.debug) {
                                                console.log(_chalk2.default.cyan("CWD:" + cwd + " Project Suffix:" + projectSuffix + "\n destination:" + destFileLocation + "\n mainFile:" + mainFileLocation + "\n basePath:" + basePath + "\n\n DetectedFiles:\n" + detectedFiles));
                                            }
                                            pathMap = {};
                                            interfaces = [];
                                            // listup files containing `export default`

                                            i = 0;

                                        case 17:
                                            if (!(i < detectedFiles.length)) {
                                                _context2.next = 34;
                                                break;
                                            }

                                            relative = _path2.default.relative(basePath, detectedFiles[i]);
                                            absolute = _path2.default.resolve(detectedFiles[i]);

                                            if (!(destFileLocation === absolute || mainFileLocation === absolute || /\.d\.ts$/.test(absolute))) {
                                                _context2.next = 22;
                                                break;
                                            }

                                            return _context2.abrupt("continue", 31);

                                        case 22:
                                            _context2.next = 24;
                                            return (0, _asyncHelper.readFileAsync)(detectedFiles[i]);

                                        case 24:
                                            content = _context2.sent;

                                            if (!(content.indexOf("interface ") >= 0 && content.indexOf("class ") < 0)) {
                                                _context2.next = 30;
                                                break;
                                            }

                                            // to ignore interfaces
                                            interfaces.push(relative);
                                            return _context2.abrupt("continue", 31);

                                        case 30:
                                            pathMap[relative] = _path2.default.parse(relative);

                                        case 31:
                                            i++;
                                            _context2.next = 17;
                                            break;

                                        case 34:
                                            if (_yargs.argv.debug) {
                                                console.log(_chalk2.default.cyan("Target files:\n " + pathMap));
                                            }
                                            // separate relative path by '/' or '\'
                                            separated = {};

                                            for (keyPath in pathMap) {
                                                separated[keyPath] = pathMap[keyPath].dir.split(_path2.default.sep);
                                                separated[keyPath].push(pathMap[keyPath].name); // last element of separated[path] is file name without extension
                                            }
                                            // make structure of index
                                            structureObject = {};

                                            for (_keyPath in separated) {
                                                generateStructureRecursively(structureObject, separated[_keyPath], "");
                                            }
                                            jsonCode = (0, _stringify2.default)(structureObject, null, "  ");
                                            objectCode = asJSIndex(jsonCode, separated);
                                            imports = [];

                                            for (_keyPath2 in separated) {
                                                imports.push({
                                                    path: "./" + _keyPath2.replace(/\.js|\.ts/g, ""),
                                                    key: jsSafeString(separated[_keyPath2].reduce(function (p, c) {
                                                        return p + c;
                                                    }))
                                                });
                                            }
                                            index = 0;
                                            _iteratorNormalCompletion = true;
                                            _didIteratorError = false;
                                            _iteratorError = undefined;
                                            _context2.prev = 47;

                                            for (_iterator = (0, _getIterator3.default)(interfaces); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                                                _pathes = _step.value;

                                                index++;
                                                imports.push({
                                                    path: "./" + _pathes.replace(/\.ts/g, ""),
                                                    key: "__INTERFACE__" + index
                                                });
                                            }
                                            _context2.next = 55;
                                            break;

                                        case 51:
                                            _context2.prev = 51;
                                            _context2.t2 = _context2["catch"](47);
                                            _didIteratorError = true;
                                            _iteratorError = _context2.t2;

                                        case 55:
                                            _context2.prev = 55;
                                            _context2.prev = 56;

                                            if (!_iteratorNormalCompletion && _iterator.return) {
                                                _iterator.return();
                                            }

                                        case 58:
                                            _context2.prev = 58;

                                            if (!_didIteratorError) {
                                                _context2.next = 61;
                                                break;
                                            }

                                            throw _iteratorError;

                                        case 61:
                                            return _context2.finish(58);

                                        case 62:
                                            return _context2.finish(55);

                                        case 63:
                                            templateArgs = {
                                                exportObject: objectCode,
                                                imports: imports,
                                                mainPath: "./" + _path2.default.relative(basePath, mainFileLocation).replace(/\.ts|\.js/g, ""),
                                                registerCode: projectSuffix ? "window[\"GrimoireJS\"].lib." + projectSuffix + " = __EXPOSE__;" : ""
                                            };

                                            if (_yargs.argv.ts) {
                                                _context2.next = 73;
                                                break;
                                            }

                                            _context2.t3 = _path2.default.join(cwd, _yargs.argv.dest);
                                            _context2.next = 68;
                                            return (0, _asyncHelper.templateAsync)(_path2.default.normalize(__dirname + "/../../src/generate-exposure/index-template.template"), templateArgs);

                                        case 68:
                                            _context2.t4 = _context2.sent;
                                            _context2.next = 71;
                                            return (0, _asyncHelper.writeFileAsync)(_context2.t3, _context2.t4);

                                        case 71:
                                            _context2.next = 74;
                                            break;

                                        case 73:
                                            return _context2.delegateYield(_regenerator2.default.mark(function _callee() {
                                                var dtsGlobPath, mainFileRelativeWithoutExt, destFileRelativeWithoutExt, pathes, filteredPath, _i;

                                                return _regenerator2.default.wrap(function _callee$(_context) {
                                                    while (1) {
                                                        switch (_context.prev = _context.next) {
                                                            case 0:
                                                                _context.t0 = _path2.default.join(cwd, _yargs.argv.dest);
                                                                _context.next = 3;
                                                                return (0, _asyncHelper.templateAsync)(_path2.default.normalize(__dirname + "/../../src/generate-exposure/ts-template.template"), templateArgs);

                                                            case 3:
                                                                _context.t1 = _context.sent;
                                                                _context.next = 6;
                                                                return (0, _asyncHelper.writeFileAsync)(_context.t0, _context.t1);

                                                            case 6:
                                                                dtsGlobPath = _path2.default.join(cwd, _yargs.argv.dts, "**/*.d.ts");
                                                                mainFileRelativeWithoutExt = _path2.default.relative(basePath, mainFileLocation).replace(/\.ts|\.js/, "");
                                                                destFileRelativeWithoutExt = _path2.default.relative(basePath, destFileLocation).replace(/\.ts|\.js/, "");
                                                                _context.next = 11;
                                                                return (0, _asyncHelper.globAsync)(dtsGlobPath);

                                                            case 11:
                                                                pathes = _context.sent;
                                                                filteredPath = pathes.map(function (p) {
                                                                    return _path2.default.relative(_path2.default.resolve(cwd, _yargs.argv.dts), p);
                                                                }).map(function (p) {
                                                                    return p.replace(/\.d\.ts$/, "");
                                                                }).filter(function (f) {
                                                                    return f !== mainFileRelativeWithoutExt;
                                                                });

                                                                if (_yargs.argv.debug) {
                                                                    console.log(_chalk2.default.cyan("Filtered js generation path:\n" + filteredPath));
                                                                }
                                                                _i = 0;

                                                            case 15:
                                                                if (!(_i < filteredPath.length)) {
                                                                    _context.next = 25;
                                                                    break;
                                                                }

                                                                if (!(filteredPath[_i] === destFileRelativeWithoutExt)) {
                                                                    _context.next = 20;
                                                                    break;
                                                                }

                                                                _context.next = 19;
                                                                return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, filteredPath[_i] + ".js"), genRefCode([], projectSuffix));

                                                            case 19:
                                                                return _context.abrupt("continue", 22);

                                                            case 20:
                                                                _context.next = 22;
                                                                return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, filteredPath[_i] + ".js"), genRefCode(filteredPath[_i].split(_path2.default.sep), projectSuffix));

                                                            case 22:
                                                                _i++;
                                                                _context.next = 15;
                                                                break;

                                                            case 25:
                                                            case "end":
                                                                return _context.stop();
                                                        }
                                                    }
                                                }, _callee, _this);
                                            })(), "t5", 74);

                                        case 74:
                                        case "end":
                                            return _context2.stop();
                                    }
                                }
                            }, _callee2, _this, [[47, 51, 55, 63], [56,, 58, 62]]);
                        })(), "t0", 2);

                    case 2:
                        _context3.next = 7;
                        break;

                    case 4:
                        _context3.prev = 4;
                        _context3.t1 = _context3["catch"](0);

                        console.log(_context3.t1);

                    case 7:
                    case "end":
                        return _context3.stop();
                }
            }
        }, _callee3, this, [[0, 4]]);
    }));

    return function generateIndex() {
        return _ref.apply(this, arguments);
    };
}();

var _asyncHelper = require("../async-helper");

var _yargs = require("yargs");

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getSuffix(name) {
    var regex = /^grimoirejs\-?(.+)?/;
    var regexResult = void 0;
    if (regexResult = regex.exec(name)) {
        if (regexResult[1]) {
            return jsSafeString(regexResult[1]);
        } else {
            return undefined;
        }
    } else {
        console.warn(_chalk2.default.bgBlack.yellow("Project name " + name + " is not valid for grimoirejs package."));
        return jsSafeString(name);
    }
}

function generateStructureRecursively(obj, sepDirs, basePath) {
    if (sepDirs.length < 2) {
        return;
    }
    if (sepDirs[0] === '') {
        obj[sepDirs[1]] = jsSafeString(basePath + sepDirs[1]);
        return;
    }
    basePath = basePath + sepDirs[0];
    if (sepDirs[0] !== '' && obj[sepDirs[0]] === void 0) {
        obj[sepDirs[0]] = {};
    }
    if (sepDirs.length > 2) {
        generateStructureRecursively(obj[sepDirs[0]], sepDirs.slice(1), basePath);
    } else if (sepDirs.length === 2) {
        obj[sepDirs[0]][sepDirs[1]] = jsSafeString(basePath + sepDirs[1]);
    }
}

function jsSafeString(str) {
    return str.replace(/\./g, "_").replace(/\-/g, "_");
}

function asJSIndex(jsonStr, sepDirs) {
    for (var pathKey in sepDirs) {
        var keyName = jsSafeString(sepDirs[pathKey].reduce(function (p, c) {
            return p + c;
        }));
        var regex = new RegExp("(: *)\"" + keyName + "\"");
        jsonStr = jsonStr.replace(regex, "$1" + keyName);
    }
    return jsonStr;
}

generateIndex();